Index: trunk/kernel/syscalls/sys_thread_wakeup.c
===================================================================
--- trunk/kernel/syscalls/sys_thread_wakeup.c	(revision 690)
+++ trunk/kernel/syscalls/sys_thread_wakeup.c	(revision 1)
@@ -1,16 +1,15 @@
 /*
- * sys_thread_wakeup.c - unblock indicated thread from the SLEEP condition
+ * kern/sys_thread_wakeup.c - wakeup all indicated threads
  * 
- * Author    Alain Greiner     (2016,2017,2018,2019,2020)
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
  *
- * Copyright (c) UPMC Sorbonne Universites
+ * This file is part of ALMOS-kernel.
  *
- * This file is part of ALMOS-MKH.
- *
- * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -18,94 +17,115 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <hal_kernel_types.h>
+#include <errno.h>
+#include <kmagics.h>
+#include <cpu.h>
+#include <kdmsg.h>
+#include <cluster.h>
+#include <task.h>
+#include <scheduler.h>
 #include <thread.h>
-#include <printk.h>
-#include <process.h>
-#include <errno.h>
-#include <syscalls.h>
 
-//////////////////////////////////////
-int sys_thread_wakeup( trdid_t trdid )
+/* 
+ * FIXME: define spinlock_rdlock() so all locking on task->th_lock 
+ * becoms rdlock but on join/detach/destroy 
+ */
+int sys_thread_wakeup(pthread_t tid, pthread_t *tid_tbl, uint_t count)
 {
-	thread_t  * this    = CURRENT_THREAD;
-    process_t * process = this->process;
+	struct task_s *task;
+	struct thread_s *this;
+	struct thread_s *target;
+	pthread_t tbl[100];
+	void *listner;
+	uint_t event;
+	sint_t i;
+	error_t err;
 
-#if DEBUG_SYS_THREAD_WAKEUP || DEBUG_SYSCALLS_ERROR || CONFIG_INTRUMENTATION_SYSCALLS
-cycle_t      tm_start = hal_get_cycles();
-#endif
+	this = current_thread;
+	task = this->task;
+	i = -1;
 
-#if DEBUG_SYS_THREAD_WAKEUP
-if( DEBUG_SYS_THREAD_WAKEUP < (uint32_t)tm_start )
-printk("\n[%s] thread[%x,%x] enter to activate thread %x / cycle %d\n",
-__FUNCTION__, process->pid, this->trdid, trdid, (uint32_t)tm_start );
-#endif
+	if(tid_tbl != NULL)
+	{
+		if((NOT_IN_USPACE((uint_t)tid_tbl + (count*sizeof(pthread_t)))) || 
+		   (count == 0) || (count > 100))
+		{
+			err = -1;
+			goto fail_tid_tbl;
+		}
 
-    // get target thread ltid and cxy
-    ltid_t   target_ltid = LTID_FROM_TRDID( trdid );
-    cxy_t    target_cxy  = CXY_FROM_TRDID( trdid );
+		if((err = cpu_copy_from_uspace(&tbl[0], tid_tbl, sizeof(pthread_t*) * count))) 
+			goto fail_usapce;
 
-    // check trdid argument
-	if( (target_ltid >= CONFIG_THREADS_MAX_PER_CLUSTER) ||
-        (cluster_is_active( target_cxy ) == false) )  
+		if(tbl[0] != tid)
+		{
+			err = -2;
+			goto fail_first_tid;
+		}
+	}
+	else
 	{
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[ERROR] in %s : thread[%x,%x] / illegal trdid argument %x\n",
-__FUNCTION__, process->pid, this->trdid, trdid );
-#endif
-		this->errno = EINVAL;
-		return -1;
+		count = 1;
+		tbl[0] = tid;
 	}
 
-    // get extended pointer on target thread
-    xptr_t thread_xp = thread_get_xptr( process->pid , trdid );
+	for(i = 0; i < count; i++)
+	{
+		tid = tbl[i];
 
-    if( thread_xp == XPTR_NULL )
-    {
+		if(tid > task->max_order)
+		{
+			err = -3;
+			goto fail_tid;
+		}
 
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[ERROR] in %s : thread[%x,%x] / cannot find thread[%x,%x]\n",
-__FUNCTION__, process->pid, this->trdid, process->pid, trdid );
-#endif
-        CURRENT_THREAD->errno = EINVAL;
-        return -1;
-    }
+		target = task->th_tbl[tid];
+   
+		if((target == NULL) || (target->signature != THREAD_ID))
+		{
+			err = -4;
+			goto fail_target;
+		}
 
-    // get target thread cluster and local pointer
-    thread_t * tgt_ptr = GET_PTR( thread_xp );
-    cxy_t      tgt_cxy = GET_CXY( thread_xp );
+		listner = sched_get_listner(target, SCHED_OP_UWAKEUP);
+		event = sched_event_make(target,SCHED_OP_UWAKEUP);
+    
+		if(this->info.isTraced == true)
+		{
+			printk(INFO,"%s: tid %d --> tid %d [%d][%d]\n", 
+			       __FUNCTION__, 
+			       this->info.order, 
+			       tid, 
+			       cpu_time_stamp(),
+			       i);
+		}
 
-    // get state of the target thread alarm
-    bool_t linked = hal_remote_l32( XPTR( tgt_cxy , &tgt_ptr->alarm.linked ) );
+		sched_event_send(listner,event);
+		cpu_wbflush();
+	}
 
-    // delete the alarm if active
-    if( linked ) alarm_stop( thread_xp );
+	return 0;
 
-    // unblock target thread
-    thread_unblock( thread_xp , THREAD_BLOCKED_SLEEP );
+fail_target:
+fail_tid:
+fail_first_tid:
+fail_usapce:
+fail_tid_tbl:
 
-#if (DEBUG_SYS_THREAD_WAKEUP || CONFIG_INSTRUMENTATION_SYSCALLS)
-uint64_t     tm_end = hal_get_cycles();
-#endif
-
-
-#if DEBUG_SYS_THREAD_WAKEUP
-if( DEBUG_SYS_THREAD_WAKEUP < tm_end )
-printk("\n[%s] thread[%x,%x] exit / thread[%x,%x] activated / cycle %d\n",
-__FUNCTION__ , process->pid, this->trdid, process->pid, trdid, (uint32_t)tm_end );
-#endif
-
-#if CONFIG_INSTRUMENTATION_SYSCALLS
-hal_atomic_add( &syscalls_cumul_cost[SYS_THREAD_WAKEUP] , tm_end - tm_start );
-hal_atomic_add( &syscalls_occurences[SYS_THREAD_WAKEUP] , 1 );
-#endif
-
-    return 0;
-
-}  // end sys_thread_wakeup()
+	printk(INFO, "%s: cpu %d, pid %d, tid %x, i %d, count %d, ttid %x, request has failed with err %d [%d]\n",
+	       __FUNCTION__,
+	       cpu_get_id(),
+	       task->pid,
+	       this,
+	       i,
+	       count,
+	       tid,
+	       err,
+	       cpu_time_stamp());
+  
+	this->info.errno = EINVAL;
+	return -1;
+}
Index: trunk/kernel/syscalls/sys_thread_yield.c
===================================================================
--- trunk/kernel/syscalls/sys_thread_yield.c	(revision 690)
+++ trunk/kernel/syscalls/sys_thread_yield.c	(revision 1)
@@ -1,16 +1,15 @@
 /*
- * sys_thread_yield.c - calls the scheduler to yield 
+ * kern/sys_thread_yield.c - calls the scheduler to yield current CPU
  * 
- * Authors       Alain Greiner (2016,2017)
- *
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
  * Copyright (c) 2011,2012 UPMC Sorbonne Universites
  *
- * This file is part of ALMOS-MKH.
+ * This file is part of ALMOS-kernel.
  *
- * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -18,37 +17,13 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <hal_kernel_types.h>
-#include <hal_special.h>
+#include <thread.h>
 #include <scheduler.h>
-#include <thread.h>
 
-#include <syscalls.h>
-
-int sys_thread_yield( void )
+int sys_thread_yield()
 {
- 
-#if DEBUG_SYS_THREAD_YIELD
-uint64_t     tm_start;
-uint64_t     tm_end;
-tm_start = hal_get_cycles();
-if( DEBUG_SYS_THREAD_YIELD < tm_start )
-printk("\n[DBG] %s : thread %x in process %x deschedule / cycle %d\n",
-__FUNCTION__, CURRENT_THREAD->trdid, CURRENT_THREAD->process->pid, (uint32_t)tm_start );
-#endif
-
-    // deschedule
-	sched_yield("user request"); 
-
-#if DEBUG_SYS_THREAD_YIELD
-tm_end = hal_get_cycles();
-if( DEBUG_SYS_THREAD_YIELD < tm_start )
-printk("\n[DBG] %s : thread %x in process %x resume / cycle %d\n",
-__FUNCTION__, CURRENT_THREAD->trdid, CURRENT_THREAD->process->pid, (uint32_t)tm_end );
-#endif
-
-	return 0;
+	return sched_yield(current_thread); 
 }
Index: trunk/kernel/syscalls/sys_times.c
===================================================================
--- trunk/kernel/syscalls/sys_times.c	(revision 1)
+++ trunk/kernel/syscalls/sys_times.c	(revision 1)
@@ -0,0 +1,58 @@
+/*
+ * times.c: thread sus/usr time
+ * 
+ * Copyright (c) 2015 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+
+
+#include <cpu.h>
+#include <thread.h>
+#include <time.h>
+
+int sys_times(struct tms *utms)
+{
+#ifdef CONFIG_THREAD_TIME_STAT
+	struct thread_s *this;
+	struct tms _tms;
+	error_t err;
+
+	if((utms == NULL) || NOT_IN_USPACE((uint_t)utms) || 
+		NOT_IN_USPACE((uint_t)utms+sizeof(struct tms)))
+	{
+		return EINVAL;
+	}
+
+	this = current_thread;
+
+	_tms.tms_utime = this->info.tm_usr;
+	_tms.tms_stime = this->info.tm_sys;
+	_tms.tms_cutime = 0;
+	_tms.tms_cstime = 0;
+	
+	err =  cpu_copy_to_uspace(utms, &_tms, sizeof(struct tms));
+
+	this->info.errno = err;
+	if(err)	return -1;
+	return 0; 
+#else
+	this->info.errno = ENOTSUPPORTED;
+	return -1;
+
+#endif
+}
Index: trunk/kernel/syscalls/sys_unlink.c
===================================================================
--- trunk/kernel/syscalls/sys_unlink.c	(revision 690)
+++ trunk/kernel/syscalls/sys_unlink.c	(revision 1)
@@ -1,16 +1,15 @@
 /*
- * sys_unlink.c - unlink a file or directorya from VFS
- *
- * Author     Alain Greiner (2016,2017,2018,2019)
- *
- * Copyright (c)  UPMC Sorbonne Universites
+ * kern/sys_unlink.c - file unlink
+ * 
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
  *
  * This file is part of ALMOS-kernel.
  *
- * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -18,102 +17,25 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <kernel_config.h>
-#include <hal_kernel_types.h>
-#include <hal_uspace.h>
-#include <errno.h>
 #include <vfs.h>
-#include <process.h>
+#include <sys-vfs.h>
+#include <task.h>
 #include <thread.h>
-#include <printk.h>
 
-#include <syscalls.h>
+int sys_unlink (char *pathname)
+{
+	error_t err = 0;
+	struct ku_obj ku_path;
 
-//////////////////////////////////
-int sys_unlink ( char * pathname )
-{
-    error_t   error;
-    xptr_t    root_inode_xp;           // extended pointer on path root inode
-
-    char      kbuf[CONFIG_VFS_MAX_PATH_LENGTH];
-
-    thread_t     * this     = CURRENT_THREAD;
-    process_t    * process  = this->process;
-
-#if (DEBUG_SYS_UNLINK || CONFIG_INSTRUMENTATION_SYSCALLS)
-uint64_t     tm_start = hal_get_cycles();
-#endif
-
-    // check pathname length
-    if( hal_strlen_from_uspace( pathname ) >= CONFIG_VFS_MAX_PATH_LENGTH )
-    {
-
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s : pathname too long\n", __FUNCTION__ );
-#endif
-        this->errno = ENFILE;
-        return -1;
-    }
-
-    // copy pathname in kernel space
-    hal_strcpy_from_uspace( XPTR( local_cxy , kbuf ),
-                            pathname,
-                            CONFIG_VFS_MAX_PATH_LENGTH );
-
-#if DEBUG_SYS_UNLINK
-if( DEBUG_SYS_UNLINK < tm_start )
-printk("\n[%s] thread[%x,%x] enter for <%s> / cycle %d\n",
-__FUNCTION__, process->pid, this->trdid, kbuf, (uint32_t)tm_start );
-#endif
- 
-    // compute root inode for path 
-    if( kbuf[0] == '/' )                        // absolute path
-    {
-        // use extended pointer on VFS root inode
-        root_inode_xp = process->vfs_root_xp;
-    }
-    else                                        // relative path
-    {
-        // get cluster and local pointer on reference process
-        xptr_t      ref_xp  = process->ref_xp;
-        process_t * ref_ptr = (process_t *)GET_PTR( ref_xp );
-        cxy_t       ref_cxy = GET_CXY( ref_xp );
-
-        // use extended pointer on CWD inode
-        root_inode_xp = hal_remote_l64( XPTR( ref_cxy , &ref_ptr->cwd_xp ) );
-    }
-
-    // call the relevant VFS function
-    error  = vfs_unlink( root_inode_xp , kbuf );
-
-    if( error )
-    {
-
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s : cannot unlink file/dir %s\n", __FUNCTION__, kbuf );
-#endif
-        this->errno = ENFILE;
-        return -1;
-    }
-
-#if (DEBUG_SYS_UNLINK || CONFIG_INSTRUMENTATION_SYSCALLS)
-uint64_t     tm_end = hal_get_cycles();
-#endif
-
-#if DEBUG_SYS_UNLINK
-if( DEBUG_SYS_UNLINK < tm_end )
-printk("\n[%s] thread[%x,%x] exit for <%s> / cycle %d\n",
-__FUNCTION__, process->pid, this->trdid, kbuf, (uint32_t)tm_end );
-#endif
- 
-#if CONFIG_INSTRUMENTATION_SYSCALLS
-hal_atomic_add( &syscalls_cumul_cost[SYS_UNLINK] , tm_end - tm_start );
-hal_atomic_add( &syscalls_occurences[SYS_UNLINK] , 1 );
-#endif
-
-    return 0;
-
-} // end sys_unlink()
+	KU_BUFF(ku_path, pathname);
+	if((err = vfs_unlink(&current_task->vfs_cwd, &ku_path)))
+	{
+		current_thread->info.errno = (err < 0) ? -err : err;
+		return -1;
+	}
+  
+	return 0;
+}
Index: trunk/kernel/syscalls/sys_utls.c
===================================================================
--- trunk/kernel/syscalls/sys_utls.c	(revision 690)
+++ trunk/kernel/syscalls/sys_utls.c	(revision 1)
@@ -2,16 +2,14 @@
  * kern/sys_utls.c - User Thread Local Storage
  * 
- * Author    Ghassan Almaless (2008,2009,2010,2011,2012)
- *           Alain Greiner (2016,2017)
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
  *
- * Copyright (c) UPMC Sorbonne Universites
+ * This file is part of ALMOS-kernel.
  *
- * This file is part of ALMOS-MKH.
- *
- * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -19,37 +17,38 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <hal_kernel_types.h>
+#include <types.h>
 #include <errno.h>
 #include <thread.h>
-#include <printk.h>
-#include <syscalls.h>
+#include <kmem.h>
+#include <kmagics.h>
+#include <semaphore.h>
 
-/////////////////////////////////
-int sys_utls( uint32_t operation,
-              uint32_t value )
+#define UTLS_SET       1
+#define UTLS_GET       2
+#define UTLS_GET_ERRNO 3
+
+int sys_utls(uint_t operation, uint_t value)
 {
-    thread_t * this = CURRENT_THREAD;
+	struct thread_s *this = current_thread;
   
 	switch(operation)
 	{
-	    case UTLS_SET:
-		this->utls = value;
+	case UTLS_SET:
+		this->info.usr_tls = value;
 		return 0;
 
-	    case UTLS_GET:
-		return this->utls;
+	case UTLS_GET:
+		return this->info.usr_tls;
 
-	    case UTLS_GET_ERRNO:
-		return this->errno;
+	case UTLS_GET_ERRNO:
+		return this->info.errno;
 
-	    default:
-        printk("\n[ERROR] in %s : illegal utls operation\n", __FUNCTION__ );
-		this->errno = EINVAL;
+	default:
+		this->info.errno = EINVAL;
 		return -1;
 	}
-
-}  // end sys_utls()
+}
Index: trunk/kernel/syscalls/sys_vector.c
===================================================================
--- trunk/kernel/syscalls/sys_vector.c	(revision 1)
+++ trunk/kernel/syscalls/sys_vector.c	(revision 1)
@@ -0,0 +1,198 @@
+/*
+ * syscall.c - kernel unified syscall entry-point
+ * 
+ * Author Ghassan Almaless (2008,2009,2010,2011,2012)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH.is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH.is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH.; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <syscall.h>
+#include <errno.h>
+#include <time.h>
+#include <cpu.h>
+#include <dma.h>
+#include <thread.h>
+#include <process.h>
+#include <scheduler.h>
+#include <kmem.h>
+#include <kdmsg.h>
+#include <sys-vfs.h>
+#include <cpu-trace.h>
+#include <semaphore.h>
+#include <cond_var.h>
+#include <barrier.h>
+#include <rwlock.h>
+#include <vmm.h>
+#include <signal.h>
+#include <page.h>
+
+/////////////////////////////////
+static error_t sys_notAvailable()
+{
+	printk(WARNING, "WARNING: Undefined system call\n");
+	return ENOSYS;
+}
+
+//////////////////////////////////////////////////////////////////////////
+// Syscall vector definition
+//////////////////////////////////////////////////////////////////////////
+
+typedef int (*sys_func_t) ();
+
+static const sys_func_t sys_call_tbl[SYSCALLS_NR] = 
+{
+	sys_thread_exit,      // 0
+	sys_mmap,             // 1
+	sys_thread_create,    // 2
+	sys_thread_join,      // 3
+	sys_thread_detach,    // 4
+	sys_thread_yield,     // 5
+	sys_sem,              // 6
+	sys_cond_var,         // 7
+	sys_barrier,          // 8
+	sys_rwlock,           // 9
+	sys_thread_sleep,     // 10
+	sys_thread_wakeup,    // 11
+	sys_open,             // 12
+	sys_creat,            // 13
+	sys_read,             // 14
+	sys_write,            // 15
+	sys_lseek,            // 16
+	sys_close,            // 17
+	sys_unlink,           // 18
+	sys_pipe,             // 19
+	sys_chdir,            // 20
+	sys_mkdir,            // 21
+	sys_mkfifo,           // 22
+	sys_opendir,          // 23
+	sys_readdir,          // 24
+	sys_closedir,         // 25
+	sys_getcwd,           // 26
+	sys_clock,            // 27
+	sys_alarm,            // 28
+	sys_dma_memcpy,       // 29
+	sys_utls,             // 30
+	sys_notAvailable,	  // 31	 reserved for sigreturn TODO ??? [AG]
+	sys_signal,           // 32
+	sys_sigreturn_setup,  // 33
+	sys_kill,             // 34
+	sys_getpid,           // 35
+	sys_fork,             // 36
+	sys_exec,             // 37
+	sys_thread_getattr,   // 38
+	sys_ps,               // 39
+	sys_madvise,          // 40
+	sys_mcntl,            // 41
+	sys_stat,             // 42
+	sys_thread_migrate,   // 43
+	sys_sbrk,             // 44
+	sys_rmdir,            // 45
+	sys_ftime,            // 46
+	sys_chmod,            // 47
+	sys_fsync,            // 48
+	sys_gettimeofday,     // 49
+	sys_times             // 50
+};
+
+/////////////////////////////
+reg_t do_syscall ( reg_t arg0,
+		           reg_t arg1,
+		           reg_t arg2,
+		           reg_t arg3,
+		           reg_t service_num )
+  
+{
+	int32_t    return_val = 0;                        // default value 
+    thread_t * this       = CURRENT_THREAD;
+	cpu_t    * cpu        = thread_current_cpu( this );
+	
+    // change thread state
+	this->state = S_KERNEL;
+	
+    // prepare kernel time computation
+	tm_usr_compute( this );
+
+/*  TODO Pourqoi cette sauvegarde ? [AG]
+	return_val = cpu_context_save( &this->info.pss );
+   
+	if(return_val != 0)
+	{
+		// Reload these pointers as the process may be forked
+		this = CURRENT_THREAD;
+		cpu  = current_cpu;
+		cpu_wbflush();
+		
+		return_val = this->info.retval;
+		goto END_DO_SYSCALL;
+	}
+*/
+
+    // check syscall index
+	if( service_num >= SYSCALLS_NR )
+	{
+		printk(INFO, "INFO %s : Undefined sysccall %d / thread = %x in cluster %x\n",
+		       __FUNCTION__, service_num, this, cluster_cxy );
+
+		this->info.errno = ENOSYS;
+		goto END_DO_SYSCALL;
+	}
+
+    // debug message before syscall execution
+	if( this->info.isTraced == true )
+	{
+		printk(DEBUG, "DEBUG %s : Pid %d / Tid %d / CPU %d in cluster %x\n"
+                      "           Service %d / Arg0 %x / Arg1 %x / Arg2 %x / Arg3 %x\n",
+		       __FUNCTION__, this->process->pid, this->info.order, cpu->lid, cluster_cxy,
+		       service_num, arg0, arg1, arg2, arg3);
+	}
+
+    // reset errno
+	this->info.errno = 0;
+
+    // enable interrupts
+	cpu_enable_all_irq( NULL );
+  
+    // call the proper kernel function
+	return_val = sys_call_tbl[service_num] (arg0,arg1,arg2,arg3);
+
+    // disable interrupts	
+	cpu_disable_all_irq(NULL);
+   
+    // debug message after syscall execution
+	if(this->info.isTraced == true)
+	{
+		printk(DEBUG, "DEBUG %s : Pid %d / Tid %d / CPU %d in cluster %x\n"
+		              "           Service %d / Return = %x / Error = %d\n",
+		       __FUNCTION__, this->process->pid, this->info.order, cpu->lid, cluster_cxy,
+		       service_num, return_val, this->info.errno );
+	}
+
+END_DO_SYSCALL:
+
+    // compute kernel time
+	tm_sys_compute(this);
+
+    // update thread state
+	this->info.retval = return_val;
+	this->state = S_USER;
+
+    // notify syscall completion
+	signal_notify( this );
+
+	return return_val;
+} // end do_syscall()
